#include "stdafx.h"
#include "LoadRLib.h"

#if (_WIN32_WCE < 0x0600)
_OpenThread OpenThread;
_VirtualAllocEx VirtualAllocEx;
_VirtualFreeEx VirtualFreeEx;
#endif

#ifdef _ARM_

HMODULE LoadRemoteLibrary(HANDLE hProcess, HANDLE hThread, LPCTSTR FileName)
{
	HMODULE hModule;
	void* pSrc;
	void* pDst;
	DWORD* p;
	DWORD Code[9] = {
		0xe92d5fff,	//stmdb       sp!, {r0 - r12, lr}
		0xe59f4024,	//ldr         r4, [pc, #0x24]
		0xe59f001c,	//ldr         r0, [pc, #0x1C]
		0xe1a0e00f,	//mov         lr, pc
		0xe1a0f004,	//mov         pc, r4
		0xe58f000c,	//str         r0, [pc, #0xC]
		0xe8bd5fff,	//ldmia       sp!, {r0 - r12, lr}
		0xe58ff000,	//str         pc, [pc]
		0xeafffffe
//		0x00000000,	//*pbDone
//		0x00000000,	//hModule
//		0x00000000,	//&FileName
//		0x00000000,	//&LoadLibrary()
//		0x00000000,	//FileName[0]
	};
	BOOL* pbDone;
	HMODULE* phModule;
	CONTEXT Context;
	CONTEXT NewContext;
	hModule = NULL;
	if(pSrc = VirtualAlloc(NULL, 65536, MEM_COMMIT, PAGE_EXECUTE_READWRITE))
	{
		if(pDst = VirtualAllocEx(hProcess, NULL, 65536, MEM_COMMIT, PAGE_EXECUTE_READWRITE))
		{
			p = (DWORD*)pSrc;
			memcpy(p, &Code, sizeof(DWORD) * 9);
			p += 9;
			*p = (DWORD)FALSE;
			pbDone = (BOOL*)p;
			p++;
			phModule = (HMODULE*)p;
			p++;
			*p = (DWORD)pDst + sizeof(DWORD) * (9 + 4);
			p++;
#ifdef UNICODE
			*p = (DWORD)GetProcAddress(LoadLibrary(_T("coredll.dll")), _T("LoadLibraryW"));
#else
			*p = (DWORD)GetProcAddress(LoadLibrary(_T("coredll.dll")), _T("LoadLibrary"));
#endif
			p++;
			_tcscpy((TCHAR*)p, FileName);
			if(WriteProcessMemory(hProcess, pDst, pSrc, 65536, NULL))
			{
				while(true)
				{
					SuspendThread(hThread);
					Context.ContextFlags = CONTEXT_CONTROL | CONTEXT_INTEGER;
					GetThreadContext(hThread, &Context);
					if(Context.Pc < 0x40000000)
					{
						NewContext = Context;
						NewContext.Pc = (ULONG)pDst;
						SetThreadContext(hThread, &NewContext);
						break;
					}
					ResumeThread(hThread);
					Sleep(10);
				}
				ResumeThread(hThread);
				while(!(*pbDone))
				{
					ReadProcessMemory(hProcess, pDst, pSrc, 65536, NULL);
					Sleep(10);
				}
				hModule = *phModule;
				SuspendThread(hThread);
				SetThreadContext(hThread, &Context);
				ResumeThread(hThread);
			}
			VirtualFreeEx(hProcess, pSrc, 65536, MEM_DECOMMIT);
		}
		VirtualFree(pSrc, 65536, MEM_DECOMMIT);
	}
	return hModule;
}

BOOL FreeRemoteLibrary(HANDLE hProcess, HANDLE hThread, HMODULE hModule)
{
	BOOL bResult;
	void* pSrc;
	void* pDst;
	DWORD* p;
	DWORD Code[9] = {
		0xe92d5fff,	//stmdb       sp!, {r0 - r12, lr}
		0xe59f4024,	//ldr         r4, [pc, #0x24]
		0xe59f001c,	//ldr         r0, [pc, #0x1C]
		0xe1a0e00f,	//mov         lr, pc
		0xe1a0f004,	//mov         pc, r4
		0xe58f000c,	//str         r0, [pc, #0xC]
		0xe8bd5fff,	//ldmia       sp!, {r0 - r12, lr}
		0xe58ff000,	//str         pc, [pc]
		0xeafffffe
//		0x00000000,	//*pbDone
//		0x00000000,	//bResult
//		0x00000000,	//hModule
//		0x00000000,	//&FreeLibrary()
	};
	BOOL* pbDone;
	BOOL* pbResult;
	CONTEXT Context;
	CONTEXT NewContext;
	bResult = FALSE;
	if(pSrc = VirtualAlloc(NULL, 65536, MEM_COMMIT, PAGE_EXECUTE_READWRITE))
	{
		if(pDst = VirtualAllocEx(hProcess, NULL, 65536, MEM_COMMIT, PAGE_EXECUTE_READWRITE))
		{
			p = (DWORD*)pSrc;
			memcpy(p, &Code, sizeof(DWORD) * 9);
			p += 9;
			*p = (DWORD)FALSE;
			pbDone = (BOOL*)p;
			p++;
			pbResult = (BOOL*)p;
			p++;
			*p = (DWORD)hModule;
			p++;
			*p = (DWORD)GetProcAddress(LoadLibrary(_T("coredll.dll")), _T("FreeLibrary"));
			p++;
			if(WriteProcessMemory(hProcess, pDst, pSrc, 65536, NULL))
			{
				while(true)
				{
					SuspendThread(hThread);
					Context.ContextFlags = CONTEXT_CONTROL | CONTEXT_INTEGER;
					GetThreadContext(hThread, &Context);
					if(Context.Pc < 0x40000000)
					{
						NewContext = Context;
						NewContext.Pc = (ULONG)pDst;
						SetThreadContext(hThread, &NewContext);
						break;
					}
					ResumeThread(hThread);
					Sleep(10);
				}
				ResumeThread(hThread);
				while(!(*pbDone))
				{
					ReadProcessMemory(hProcess, pDst, pSrc, 65536, NULL);
					Sleep(10);
				}
				bResult = *pbResult;
				SuspendThread(hThread);
				SetThreadContext(hThread, &Context);
				ResumeThread(hThread);
			}
			VirtualFreeEx(hProcess, pSrc, 65536, MEM_DECOMMIT);
		}
		VirtualFree(pSrc, 65536, MEM_DECOMMIT);
	}
	return bResult;
}

HMODULE InjectDLLIntoWindow(HWND hTargetWnd, LPCTSTR FileName)
{
	HMODULE hModule;
	DWORD ProcessId;
	DWORD ThreadId;
	HANDLE hProcess;
	HANDLE hThread;
	hModule = NULL;
	ThreadId = GetWindowThreadProcessId(hTargetWnd, &ProcessId);
	if(ThreadId != 0)
	{
		if(hProcess = OpenProcess(0, FALSE, ProcessId))
		{
			if(hThread = OpenThread(0, FALSE, ThreadId))
			{
				hModule = LoadRemoteLibrary(hProcess, hThread, FileName);
				CloseHandle(hThread);
			}
			CloseHandle(hProcess);
		}
	}
	return hModule;
}

BOOL EjectDLLFromWindow(HWND hTargetWnd, HMODULE hModule)
{
	BOOL bResult;
	DWORD ProcessId;
	DWORD ThreadId;
	HANDLE hProcess;
	HANDLE hThread;
	bResult = FALSE;
	ThreadId = GetWindowThreadProcessId(hTargetWnd, &ProcessId);
	if(ThreadId != 0)
	{
		if(hProcess = OpenProcess(0, FALSE, ProcessId))
		{
			if(hThread = OpenThread(0, FALSE, ThreadId))
			{
				bResult = FreeRemoteLibrary(hProcess, hThread, hModule);
				CloseHandle(hThread);
			}
			CloseHandle(hProcess);
		}
	}
	return bResult;
}

void InitializeCE6Function()
{
#if (_WIN32_WCE < 0x0600)
	HMODULE hModule;
	hModule = LoadLibrary(_T("coredll.dll"));
	VirtualAllocEx = (_VirtualAllocEx)GetProcAddress(hModule, _T("VirtualAllocEx"));
	VirtualFreeEx = (_VirtualFreeEx)GetProcAddress(hModule, _T("VirtualFreeEx"));
	OpenThread = (_OpenThread)GetProcAddress(hModule, _T("OpenThread"));
#endif
}

#endif

